<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.mediator.event.ui.EventingSourceAdminClient" %>
<%@ page import="org.wso2.carbon.mediator.event.ui.service.xsd.dto.EventSourceDTO" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.event.EventMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon"%>

<%
		EventingSourceAdminClient client = null;
		String backendServerURL = null;
		ConfigurationContext configContext = null;
		String cookie = null;
	    EventSourceDTO[] eventSources = null;
        String existingEventSource;

        backendServerURL = CarbonUIUtil.getServerURL(config
				.getServletContext(), session);
		configContext = (ConfigurationContext) config.getServletContext()
				.getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

		try {
			cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
			client = new EventingSourceAdminClient(cookie, backendServerURL,configContext);
			eventSources = client.getEventSources();

            Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
            if (!(mediator instanceof EventMediator)) {
                // todo : proper error handling
                throw new RuntimeException("Unable to update the mediator");
            }
            EventMediator eventMediator = (EventMediator)mediator;
            existingEventSource = eventMediator.getEventSourceName();

        } catch (Exception e) {
            CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
            <script type="text/javascript">
                   location.href = "../admin/error.jsp";
            </script>
    <%
            return;
        }
%>

<fmt:bundle basename="org.wso2.carbon.mediator.event.ui.i18n.Resources">
    <carbon:jsi18n
        resourceBundle="org.wso2.carbon.mediator.event.ui.i18n.JSResources"
        request="<%=request%>"
        i18nObjectName="eventi18n"/>    
<div>
    <script type="text/javascript" src="../event-mediator/js/mediator-util.js"></script>

    <table class="normal" width="100%">
        <tr>
            <td>
                <h2><fmt:message key="mediator.event.header"/></h2>
            </td>
        </tr>

        <tr>
            <td>
                <table class="normal">
                    <tr>
                        <td>
                            <fmt:message key="mediator.event.source"/>
                        </td>
                        <td>
                            <select name="mediator.event.source" id="mediator.event.source">
                            <%
                                if(existingEventSource == null){
                            %>
                            <option value="selectEventSource" selected="true" ><fmt:message key="mediator.event.select.event.source"/></option>
                            <%
                                }
                                if(eventSources != null){
                                    for(EventSourceDTO eventSource:eventSources){
                                        String eventSourceStr = eventSource.getName();
                                        if(eventSourceStr.equals(existingEventSource)){
                            %>
                            <option value="<%=eventSourceStr%>" selected="selected"><%=eventSourceStr%></option>
                            <%
                                        } else {
                            %>
                            <option value="<%=eventSourceStr%>" ><%=eventSourceStr%></option>
                            <%
                                        }
                                    }
                                }
                            %>
                            </select>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</div>
</fmt:bundle>