<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.XPathFactory" %>
<%@ page import="org.wso2.carbon.mediator.validate.ValidateMediator" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.List" %>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof ValidateMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    ValidateMediator validateMediator = (ValidateMediator) mediator;

    // set keys
    List<String> schemaKeyList = new ArrayList<String>();
    String keyCountParameter = request.getParameter("keyCount");
    if (keyCountParameter != null && !"".equals(keyCountParameter)) {
        int keyCount = 0;
        try {
            keyCount = Integer.parseInt(keyCountParameter.trim());
        } catch (NumberFormatException e) {
            throw new RuntimeException("Invalid number format");
        }
        for (int i = 0; i <= keyCount; i++) {
            String keyValue = request.getParameter("key" + i);
            if (keyValue != null && !"".equals(keyValue)) {
                schemaKeyList.add(keyValue);
            }
        }
        validateMediator.setSchemaKeys(schemaKeyList);
    }

    // set source
    String sourceParameter = request.getParameter("mediator.validate.source");
    XPathFactory xPathFactory = XPathFactory.getInstance();
    if (sourceParameter != null && !"".equals(sourceParameter)) {
        validateMediator.setSource(xPathFactory.createSynapseXPath("mediator.validate.source", sourceParameter.trim(), session));
    } else if ("".equals(sourceParameter)) {
        validateMediator.setSource(null);
    }

    // set features
    String featureCountParameter = request.getParameter("featureCount");
    if (featureCountParameter != null && !"".equals(featureCountParameter)) {
        int featureCount = 0;
        try {
            featureCount = Integer.parseInt(featureCountParameter);
        } catch (NumberFormatException e) {
            throw new RuntimeException("Invalid number format");
        }
        // avoid duplications
        validateMediator.getFeatures().clear();
        for (int i = 0; i <= featureCount; i++) {
            String featureName = request.getParameter("featureName" + i);
            if (featureName != null && !"".equals(featureName)) {
                validateMediator.addFeature(featureName, true); // TODO:always pass true ?
            }
        }
    }

%>

