<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.apache.synapse.util.xpath.SynapseXPath" %>
<%@ page import="org.wso2.carbon.mediator.service.ui.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.xslt.XSLTMediator" %>
<%@ page import="org.wso2.carbon.mediator.service.util.MediatorProperty" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.NameSpacesRegistrar" %>
<%@ page import="java.util.List" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<jsp:include page="../resources/resources-i18n-ajaxprocessor.jsp"/>

<fmt:bundle basename="org.wso2.carbon.mediator.xslt.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.mediator.xslt.i18n.JSResources"
        request="<%=request%>" i18nObjectName="xsltjsi18n"/>
<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof XSLTMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    XSLTMediator xsltMediator = (XSLTMediator) mediator;
    String key = xsltMediator.getXsltKey();
    if (key == null) {
        key = "";
    }
    SynapseXPath sourceXPath = xsltMediator.getSource();
    String source = "";
    NameSpacesRegistrar nameSpacesRegistrar = NameSpacesRegistrar.getInstance();
    if (sourceXPath != null) {
        nameSpacesRegistrar.registerNameSpaces(sourceXPath, "mediator.xslt.source", session);
        source = sourceXPath.toString();
    }
    List<MediatorProperty> mediatorPropertyList = xsltMediator.getProperties();
    nameSpacesRegistrar.registerNameSpaces(mediatorPropertyList, "propertyValue", session);
    List<MediatorProperty> featureList = xsltMediator.getFeatures();
    String propertyTableStyle = mediatorPropertyList.isEmpty() ? "display:none;" : "";
    String featureTableStyle = featureList.isEmpty() ? "display:none;" : "";
%>
<div>
<script type="text/javascript" src="../xslt-mediator/js/mediator-util.js"></script>
<table class="normal" width="100%">
<tr>
    <td>
        <h2><fmt:message key="xslt.mediator.header"/></h2>
    </td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td>
                    <fmt:message key="mediator.xslt.key"/><span class="required">*</span>
                </td>
                <td>
                    <input class="longInput" type="text" id="mediator.xslt.key" name="mediator.xslt.key"
                           value="<%=key%>" readonly="true"/>
                </td>
                <td>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"                       
                       onclick="showRegistryBrowser('mediator.xslt.key','/_system/config')"><fmt:message
                            key="conf.registry.keys"/></a>
                    <a href="#registryBrowserLink"
                       class="registry-picker-icon-link"
                       onclick="showRegistryBrowser('mediator.xslt.key','/_system/governance')"><fmt:message
                            key="gov.registry.keys"/></a>
                </td>
            </tr>
            <tr>
                <td>
                    <fmt:message key="mediator.xslt.source"/>
                </td>
                <td>
                    <input class="longInput" type="text" id="mediator.xslt.source" name="mediator.xslt.source"
                           value="<%=source%>"/>
                </td>
                <td>
                    <a href="#nsEditorLink" class="nseditor-icon-link"
                       style="padding-left:40px"
                       onclick="showNameSpaceEditor('mediator.xslt.source')"><fmt:message
                            key="namespaces"/></a>
                </td>
            </tr>
        </table>
    </td>
</tr>
<tr>
    <td>
        <h3 class="mediator">
            <fmt:message key="properties"/></h3>

        <div style="margin-top:0px;">
            <table id="propertytable" style="<%=propertyTableStyle%>;" class="styledInner">
                <thead>
                    <tr>
                        <th width="15%"><fmt:message key="th.property.name"/></th>
                        <th width="10%"><fmt:message key="th.property.type"/></th>
                        <th width="15%"><fmt:message key="th.value.expression"/></th>
                        <th id="ns-edior-th" style="display:none;" width="15%"><fmt:message key="namespaceeditor"/></th>
                        <th><fmt:message key="th.action"/></th>
                    </tr>
                    <tbody id="propertytbody">
                        <%
                            int i = 0;
                            for (MediatorProperty mp : mediatorPropertyList) {
                                if (mp != null) {
                                    String value = mp.getValue();
                                    SynapseXPath synapseXPath = mp.getExpression();
                                    boolean isLiteral = value != null && !"".equals(value);
                        %>
                        <tr id="propertyRaw<%=i%>">
                            <td><input type="text" name="propertyName<%=i%>" id="propertyName<%=i%>"
                                       value="<%=mp.getName()%>"/>
                            </td>
                            <td>
                                <select name="propertyTypeSelection<%=i%>"
                                        id="propertyTypeSelection<%=i%>"
                                        onchange="onPropertyTypeSelectionChange('<%=i%>','<fmt:message key="namespaces"/>')">
                                    <% if (isLiteral) {%>
                                    <option value="literal">
                                        <fmt:message key="value"/>
                                    </option>
                                    <option value="expression">
                                        <fmt:message key="expression"/>
                                    </option>
                                    <%} else if (synapseXPath != null) {%>
                                    <option value="expression">
                                        <fmt:message key="expression"/>
                                    </option>
                                    <option value="literal">
                                        <fmt:message key="value"/>
                                    </option>
                                    <%} else { %>
                                    <option value="literal">
                                        <fmt:message key="value"/>
                                    </option>
                                    <option value="expression">
                                        <fmt:message key="expression"/>
                                    </option>
                                    <% }%>
                                </select>
                            </td>
                            <td>
                                <% if (value != null && !"".equals(value)) {%>
                                <input id="propertyValue<%=i%>" name="propertyValue<%=i%>" type="text"
                                       value="<%=value%>"
                                        />
                                <%} else if (synapseXPath != null) {%>
                                <input id="propertyValue<%=i%>" name="propertyValue<%=i%>" type="text"
                                       value="<%=synapseXPath.toString()%>"/>
                                <%} else { %>
                                <input id="propertyValue<%=i%>" name="propertyValue<%=i%>" type="text"/>
                                <% }%>
                            </td>
                            
                            <td id="nsEditorButtonTD<%=i%>" style="<%=isLiteral? "display:none;" : ""%>">
                                <% if (!isLiteral && synapseXPath != null) {%>
                                <script type="text/javascript">
                                    document.getElementById("ns-edior-th").style.display = "";
                                </script>
                                <a href="#nsEditorLink" class="nseditor-icon-link"
                                   style="padding-left:40px"
                                   onclick="showNameSpaceEditor('propertyValue<%=i%>')"><fmt:message
                                        key="namespaces"/></a>
                                  <%}%>
                            </td>
                          

                            <td><a href="#" class="delete-icon-link" onclick="deleteproperty('<%=i%>');return false;"><fmt:message
                                    key="delete"/></a></td>
                        </tr>
                        <% }
                            i++;
                        } %>
                        <input type="hidden" name="propertyCount" id="propertyCount" value="<%=i%>"/>
                        <script type="text/javascript">
                            if (isRemainPropertyExpressions()) {
                                resetDisplayStyle("");
                            }
                        </script>
                    </tbody>
                </thead>
            </table>
        </div>
    </td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addNameLink"></a>
            <a class="add-icon-link"
               href="#addNameLink"
               onclick="addproperty('<fmt:message key="namespaces"/>','<fmt:message key="nameemptyerror"/>','<fmt:message key="valueemptyerror"/>')"><fmt:message
                    key="add.property"/></a>
        </div>
    </td>
</tr>
<tr>
    <td>
        <h3 class="mediator"><fmt:message key="features"/></h3>

        <div style="margin-top:0px;">
            <table id="featuretable" style="<%=featureTableStyle%>;" class="styledInner">
                <thead>
                    <tr>
                        <th width="15%"><fmt:message key="th.feature.name"/></th>
                        <th width="10%"><fmt:message key="th.feature.value"/></th>
                        <th><fmt:message key="th.action"/></th>
                    </tr>
                    <tbody id="featuretbody">
                        <%
                            int k = 0;
                            for (MediatorProperty property : featureList) {
                                if (property != null) {
                                    String value = property.getValue();
                                    boolean isTrue = value != null && Boolean.valueOf(value.trim());
                        %>
                        <tr id="featureRaw<%=k%>">
                            <td><input type="text" name="featureName<%=k%>" id="featureName<%=k%>"

                                       value="<%=property.getName()%>"/>
                            </td>
                            <td>
                                <select name="featureValue<%=k%>"
                                        id="featureValue<%=k%>">
                                    <% if (!isTrue) {%>
                                    <option value="false" selected="selected">
                                        <fmt:message key="false"/>
                                    </option>
                                    <option value="true">
                                        <fmt:message key="true"/>
                                    </option>
                                    <%} else { %>
                                    <option value="true" selected="selected">
                                        <fmt:message key="true"/>
                                    </option>
                                    <option value="false">
                                        <fmt:message key="false"/>
                                    </option>
                                    <% }%>
                                </select>
                            </td>
                            <td><a href="#" href="#" class="delete-icon-link" 
                                   onclick="deletefeature('<%=k%>')"><fmt:message key="delete"/></a></td>
                        </tr>
                        <% }
                            k++;
                        } %>
                        <input type="hidden" name="featureCount" id="featureCount" value="<%=k%>"/>
                    </tbody>
                </thead>
            </table>
        </div>
    </td>
</tr>
<tr>
    <td>
        <div style="margin-top:0px;">
            <a name="addFeatureLink"></a>
            <a class="add-icon-link"
               href="#addFeatureLink"
               onclick="addfeature('<fmt:message key="nameemptyerror.feature"/>')">
                <fmt:message key="add.feature"/></a>
        </div>
    </td>
</tr>
</table>
<a name="nsEditorLink"></a>

<div id="nsEditor" style="display:none;"></div>

<a name="registryBrowserLink"></a>

<div id="registryBrowser" style="display:none;"></div>
</div>
</fmt:bundle> 